<template>
  <section class="wrapper">
    <div class="body">
      <h2>{{ $store.state.cur_loc.name }}</h2>
      <h4>{{ $store.state.cur_loc.description }}</h4>
    </div>

    <div
      class="destinations"
      v-if="displayingDests">
      <small>Select your destination:</small>
      <ul>
        <li
          v-for="dest in dests"
          :key="dest.name"
          @click="travel(dest, $event)">
          {{ dest.name }}
        </li>
      </ul>
    </div>

    <div
      class="inventory"
      v-else-if="displayingBags">
      <small>current equipments</small>
      <ul>
        <li
          v-for="equip of char.char_current_equipment"
          :key="equip">
          {{ equip }}
        </li>
      </ul>

      <small>inventory</small>
      <ul>
        <li
          v-for="i in char.bag"
          :key="i.name">
          <span
            v-if="i.equipment === undefined">
            {{ i.name }}
          </span>
          <span
            v-else
            @click="equipItem">
            {{ i.name }} (e)
          </span>
        </li>
      </ul>
    </div>

    <div class="menus">
      <b-button
        @click="showDestinations">
        travel
      </b-button>
      <b-button
        @click="showBags">
        inventory
      </b-button>
    </div>
  </section>
</template>

<script>
export default {
  data() {
    return {
      loc: null,
      dests: null,
      displayingDests: false,
      displayingBags: false
    };
  },
  computed: {
    char: {
      get() {
        return this.$store.state.cur_char;
      },
      set(value) {
        this.$store.state.cur_char = value;
      }
    }
  },
  created() {
    this.char = this.$store.state.cur_char;
    this._saveGame();
    this._recoverStats();
    this._getCurrentLocationInfo();
  },
  methods: {
    _getCurrentLocationInfo() {
      // loc = Location.find(char.current_location)
      // this.loc = loc;
      // this.paths = Paths.find_by(departure_id: loc.id)
      // this.dests = Location.where_in(id: this.paths.each.destination_id)
      this.loc = this.$store.state.cur_loc;

      this.dests = this.loc.destinations;
    },
    _saveGame() {
      let ins = this;

      let store_char = this.$store.state.user.characters.find((el, i, arr) => {
        return el._id.$oid = ins.char._id.$oid;
      });

      store_char = this.char;

      this.$axios({
        method: 'put',
        url: `http://localhost:3000/users/${this.$store.state.user._id.$oid}`,
        data: this.$store.state.user
      })
        .then(res => {
          ins.$store.state.user = res.data;
        })
        .catch(err => {
          console.log(err);
        });
    },
    _recoverStats() {
      // char = curr_char
      // char.curr_{hp,mp,ap} = char.stats.{hp,mp,ap}
      let bars = ['hp','mp','ap'];

      for (let i = 0; i < bars.length; i++)
        this.char[`curr_${bars[i]}`] = this.char.char_stat[bars[i]];
    },
    showDestinations() {
      this.displayingBags = false;
      this.displayingDests = true;
    },
    showBags() {
      this.displayingBags = true;
      this.displayingDests = false;
    },
    travel(dest, event) {
      // pega o path selecionado
      // muda para PathFrame aka BattleFrame
      // $emit para o GameFrame
      this.$store.state.cur_path = dest.path;
      this.$emit("travelling");
    },
    equipItem() {
      // equip current item
      console.log('equipa');
    }
  }
}
</script>

<style scoped>
.wrapper {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: center;
  color: antiquewhite;
}

.body {
  display: inline-flex;
  flex-direction: inherit;
  justify-content: inherit;
  align-items: inherit;
}
</style>

